#include "config.h"
#include "cyril-config.h"
#include "lib.h"

void load_config()
{
	CFG_addTool("HVFH", "HVFHconfig", "config.xml", "Hybrid VFH and A* obstacle avoidance");
	CFG_addOptionS(config, use_planning, pBool, 1, "1", "use global A* planning", "");
	CFG_addOptionS(config, record_maps, pBool, 1, "0", "record maps information in ppm image during execution", "");
	CFG_addOptionSep();
	CFG_addOptionS(config, control_period, pInt, 1, "20", "control period (not implemented) (ms)", ">0");
	CFG_addOptionS(config, planning_period, pInt, 1, "1000", "planning period (ms)", ">0");
	CFG_addOptionSep();
	CFG_addOptionS(config, global_map_file, pFile, 1, "test.bmp", "global map image file (bmp format only)", "");
	CFG_addOptionS(config, cell_size, pReal, 1, "10", "maps cells size (cm)", "");
	CFG_addOptionS(config, start_x, pReal, 1, "0", "robot start x position (cm from left)", "");
	CFG_addOptionS(config, start_y, pReal, 1, "0", "robot start y position (cm from bottom)", "");
	CFG_addOptionS(config, start_theta, pReal, 1, "90", "robot start angle (degrees from left->right axis", "");
	CFG_addOptionS(config, goal_x, pReal, 1, "0", "goal x position (cm from left)", "");
	CFG_addOptionS(config, goal_y, pReal, 1, "300", "goal y position (cm from bottom)", "");
	CFG_addOptionSep();
	CFG_addOptionS(config, max_speed, pReal, 1, "60", "maximum speed of the robot (cm/s)", "");
	CFG_addOptionS(config, max_rot_speed, pReal, 1, "300", "maximum rotation speed of the robot (deg/s)", "");
	CFG_addOptionS(config, max_decel, pReal, 1, "30", "maximum deceleration that the robot can do (cm/s^2)", "");
	CFG_addOptionSep();
	CFG_addOptionS(config, active_window_size, pInt, 1, "13", "VFH: active window side size (# of cells, odd number)", "");
	CFG_addOptionS(config, smooth_polar_width, pInt, 1, "5", "VFH: polar map smoothing half-width (# of polar cells)", "");
	CFG_addOptionS(config, polar_sectors, pInt, 1, "72", "VFH: polar map size (# of polar cells)", "");
	CFG_addOptionS(config, wide_valley_size, pInt, 1, "18", "VFH: minimum width of a valley to be said wide (# of polar cells)", "");
	CFG_addOptionS(config, max_probes, pInt, 1, "50", "VFH: ceil for number of votes of a cell", "");
	CFG_addOptionS(config, local_map_size, pInt, 1, "10", "VFH: size of the local map around the robot (# of cells, not implemented)", "");
	CFG_addOptionS(config, dilatation_size, pInt, 1, "1", "VFH: size of the dilatation of the obstacles of the global map (# of cells)", "");
	CFG_addOptionS(config, histo_thres, pReal, 1, "20", "VFH: threshold in the polar histogram for free angle", "");
	CFG_addOptionS(config, speed_reduction, pReal, 1, "100", "VFH: hm coeff of speed control, homogeneous to histo_thres (value to stop)", "");
	CFG_addOptionS(config, min_speed, pReal, 1, "5", "VFH: minimum speed given by speed control", "");
	CFG_addOptionS(config, global_memory, pBool, 1, "0", "VFH: always remember the local map (even in loops)", "");
	CFG_addOptionS(config, vote_noobst, pBool, 1, "1", "VFH: cells detected as not obstacle vote -1 to the histogram", "");
}


Config config;
