
#include "lib.h"
#include <iostream>
#include <fstream>


bool Image::readBMP(char *filename)
{
	char buffer[10]; // un buffer temporaire
	int offset, width, height, tmp4; // tmp est un buffer pour entier 4 octets
	short tmp2; // buffer pour entier sur deux octets
	char tmp1;

	std::ifstream *is = new std::ifstream(); // on cre un flux fichier
	is->open(filename, std::ios::in|std::ios::binary); // on ouvre le fichier binaire en lecture

	if(is->is_open())
	{
	 //*** lire entete fichier
		is->read(buffer, 10); // "BM", taille du fichier, 4 rservs
		if (buffer[0] != 'B' || buffer[1] != 'M')
			{ std::cout << "misc::Image::readBMP : not a bmp file (" << filename << ")" << std::endl; return false; }
		is->read((char*)&offset, 4); // offset dbut pixels
	 //*** lire entete bitmap
		is->read(buffer, 4); // taille entete
		is->read((char*)&width, 4); // largeur
		is->read((char*)&height, 4); // hauteur
		is->read((char*)&tmp2, 2); // nb de plans -> poubelle
		is->read((char*)&tmp2, 2); // depth
		if (tmp2 != 24)
			{ std::cout << "misc::Image::readBMP : not 24 bits, I don't like :p (" << filename << ")" << std::endl; return false; }
		is->read((char*)&tmp4, 4); // compression
		if (tmp4 != 0) 
			{ std::cout << "misc::Image::readBMP : compressed image, I don't like :p (" << filename << ")" << std::endl; return false; }

	 //*** lire donnes
		w = width, h = height;
		delete[] data;
		data = new uchar[width*height*3];
		is->seekg(offset); // on va directement au dbut des donnes
		// ici petite "subtilit" du bmp : une ligne doit comporter un nombre d'octets multiple de 4
		// complt par des 0 si ncessaire, donc nous on les saute
		int toJump = (width*3)%4; if (toJump != 0) toJump = 4-toJump;

		for(int j = height-1; j >= 0; j--) // autre "subtilit", les lignes sont codes de bas en haut
		{
			unsigned char *ligne = data + j*width*3;
			is->read((char*)ligne, width*3); // on lit une ligne

			// encore une "subtilit", coder en BGR c'est bien plus marrant
			for(int i = 0; i < width; i++)
			{
				tmp1 = ligne[i*3+0];
				ligne[i*3+0] = ligne[i*3+2];
				ligne[i*3+2] = tmp1;
			}

			is->seekg(toJump, std::ios::cur); // on se recale au dbut de la ligne suivante (cf "subtilit" no 1)
		}
		is->close();
		delete is;
		return true;
	} else
	{
		std::cout << "misc::Image::readBMP : impossible to read file : " << filename << std::endl;
		delete is;
		return false;
	}
}

