#ifndef _LIB_H_
#define _LIB_H_

#include <math.h>
#include <iostream>
#include "lib/cyril-macro.h"

typedef float real;
typedef unsigned char uchar;

template<typename T> inline T sqr(T x) { return x*x; }
template<typename T> inline T abs(T x) { return (x<0 ? -x : x); }
template<typename T> inline T min(T a, T b) { return (a<b ? a : b); }
template<typename T> inline T max(T a, T b) { return (a>b ? a : b); }
template<typename T> inline int sign(T x) { return (x >= 0 ? 1 : -1); }

//inline double atan4(double y, double x) { return ((x == 0) ? PI/2 : atan(y/x)) + ((y < 0) ? PI : 0); }

// modulo that always return a number between 0 and n-1 (even if x<0), and works with float and int
template<typename T> inline T mod(T x, int n) { return (x >= 0 ? x-n*(int)(x/n) : x-n*(int)(x/n)+n); }

template<typename T> inline T avg_mod(T left, T right, int n) 
	{ left = mod(left, n); right = mod(right, n); return (left <= right ? (left+right)/2 : mod((left+right+n)/2,n)); }

	
class Image
{
 public:
	int w, h;
	uchar *data; /// data[h*w*3]
	
	Image() { data = NULL; }
	bool readBMP(char *filename);
};

#endif

