#include "astar.h"
#include "datastruct.h"
#include <iostream>
#include "config.h"

#include "lib/cyril-timer.h"

int main ()
{

	config.dilatation_size = 1;

	// when the robot is started
/*	float startx = 25, starty = 35;
	float goalx = 65, goaly = 35;
	GlobalMap gm("small.bmp", 10);
*/
//	float startx = 815, starty = 895;
//	float goalx = 195, goaly = 65;
//	float goalx = 815, goaly = 895;
//	float startx = 195, starty = 65;
//	float goalx = 200, goaly = 130;
//	float startx = 400, starty = 130;
	float goalx = 205, goaly = 160;
	float startx = 415, starty = 160;
	GlobalMap gm("test2.bmp", 10);
	
	
	// when the goal is changed
	gm.goal_vtx->x = (int)(goalx / 10);
	gm.goal_vtx->y = (int)(goaly / 10);
	gm.add_goal_graph((int)(goalx / 10), (int)(goaly / 10));
	
	for(int y = 0; y < gm.h; y++) 
	{
		for(int x = 0; x < gm.w; x++)
			std::cout << (char)('0'+gm.map[x][(gm.h-1)-y]);
		std::cout << std::endl;
	}
	std::cout << std::endl;

	for(int i = 0; i < gm.nvertices; i++)
	{
		std::cout << "candidate: " << gm.vertices[i]->x << " , " << gm.vertices[i]->y << "-" << gm.h-1-gm.vertices[i]->y << " ; ";
		for(NeighborList::iterator neighbor = gm.vertices[i]->neighbors.begin(); neighbor != gm.vertices[i]->neighbors.end(); neighbor++)
			std::cout << "(" << (*neighbor).ptr->x << "," << (*neighbor).ptr->y << "-" << gm.h-1-(*neighbor).ptr->y << ")";
		std::cout << std::endl;
	}
	std::cout << std::endl;

	Date start; 
	std::list<Vertex *> res;
	
	gm.count_are_neighbors = 0;
	std::cout << std::endl;
	std::cout << "not optimized" << std::endl;
	start = get_c_us();
	res = findpath(gm, startx, starty, gm.goal_vtx);
	start = get_c_us() - start;
	std::cout << start << "s (" << gm.count_are_neighbors << " areNeighbors, " << gm.count_vtx_tested << " vtx tested)" << std::endl;
	Date t1 = start;

	for(std::list<Vertex *>::iterator it = res.begin(); it != res.end(); it++)
	{
		std::cout << "intermediate: " << (*it)->x << " , " << (*it)->y << "-" << gm.h-1-(*it)->y << std::endl;
	}


	std::cout << std::endl;
	std::cout << "optimized 1" << std::endl;
	start = get_c_us();
	res = findpath_opt1(gm, startx, starty, gm.goal_vtx);
	start = get_c_us() - start;
	std::cout << start << "s (" << gm.count_are_neighbors << " areNeighbors, " << gm.count_vtx_tested << " vtx tested)" << std::endl;
	Date t2 = start;

	for(std::list<Vertex *>::iterator it = res.begin(); it != res.end(); it++)
	{
		std::cout << "intermediate: " << (*it)->x << " , " << (*it)->y << "-" << gm.h-1-(*it)->y << std::endl;
	}


	std::cout << std::endl;
	std::cout << "optimized 2" << std::endl;
	start = get_c_us();
	res = findpath_opt2(gm, startx, starty, gm.goal_vtx);
	start = get_c_us() - start;
	std::cout << start << "s (" << gm.count_are_neighbors << " areNeighbors, " << gm.count_vtx_tested << " vtx tested)" << std::endl;
	Date t3 = start;

	for(std::list<Vertex *>::iterator it = res.begin(); it != res.end(); it++)
	{
		std::cout << "intermediate: " << (*it)->x << " , " << (*it)->y << "-" << gm.h-1-(*it)->y << std::endl;
	}
	
	
	std::cout << std::endl;
	std::cout << "optimized 3" << std::endl;
	start = get_c_us();
	res = findpath_opt3(gm, startx, starty, gm.goal_vtx);
	start = get_c_us() - start;
	std::cout << start << "s (" << gm.count_are_neighbors << " areNeighbors, " << gm.count_vtx_tested << " vtx tested)" << std::endl;
	Date t4 = start;

	for(std::list<Vertex *>::iterator it = res.begin(); it != res.end(); it++)
	{
		std::cout << "intermediate: " << (*it)->x << " , " << (*it)->y << "-" << gm.h-1-(*it)->y << std::endl;
	}

	
	std::cout << std::endl;
	std::cout << "optimized 4" << std::endl;
	start = get_c_us();
	res = findpath_opt4(gm, startx, starty, gm.goal_vtx);
	start = get_c_us() - start;
	std::cout << start << "s (" << gm.count_are_neighbors << " areNeighbors, " << gm.count_vtx_tested << " vtx tested)" << std::endl;
	Date t5 = start;

	for(std::list<Vertex *>::iterator it = res.begin(); it != res.end(); it++)
	{
		std::cout << "intermediate: " << (*it)->x << " , " << (*it)->y << "-" << gm.h-1-(*it)->y << std::endl;
	}
	
	
	
	std::cout << std::endl;
	std::cout << t1 << " ; " << t2 << " ; " << t3 << " ; " << t4 << " ; " << t5 << std::endl;
	
system("PAUSE");
	return 0;
	
}

