
#include "config.h"
#include "lib/cyril-config.h"
#include "vfh.h"
#include "io.h"


int main(int argc, char **argv)
{
	load_config();
	CFG_loadArgs(argc, argv);
	
	/// init
	Robot amigobot(33, 28, 8);
	amigobot.state.x = 400;
	amigobot.state.y = 150;
	amigobot.state.theta = 90;
	amigobot.state.speed = 0;
	amigobot.state.rot_speed = 0;
	amigobot.minSensorRange = 200;
	amigobot.maxSensorRange = 500;
	config.goal_x = 400;
	config.goal_y = 300;
	
	std::cout << mod(-1, 72) << std::endl;

	GlobalMap gm(config.global_map_file, config.cell_size);
	VFH vfh(&amigobot, gm.w, gm.h);
	
	gm.add_goal_graph((int)(config.goal_x/gm.cellSize), (int)(config.goal_y/gm.cellSize));

//	gm.goal_vtx->x = (int)(config.goal_x/gm.cellSize);
//	gm.goal_vtx->y = (int)(config.goal_y/gm.cellSize);

/*	vfh.lm->map[37][20].obst = 10;
	vfh.lm->map[38][20].obst = 20;
	vfh.lm->map[39][20].obst = 10;
	vfh.lm->map[40][20].obst = 20;
	vfh.lm->map[41][20].obst = 10;
*/
	std::list<Vertex *> list_inter; list_inter.push_back(gm.goal_vtx);
	
	float theta, vel;
	vfh.getDirSpeed(theta, vel, true);
	
	for(int i = 0; i < vfh.pm->size; i++)
		std::cout << vfh.pm->map[i] << " ";
	std::cout << std::endl;
	std::cout << "theta " << theta << " ; vel " << vel << std::endl;
	
	vfh.saveMaps("map_test.ppm", gm, &list_inter, 10);

	return 0;
}

